#!/bin/sh


# Path to the LLVM interpreter
LLI="lli"
#LLI="/usr/local/opt/llvm/bin/lli"

# Path to the LLVM compiler
LLC="llc"
#LLC="/usr/local/opt/llvm/bin/llc"

# Path to the C compiler
CC="cc"
# CC="/usr/local/opt/llvm/bin/cc"

# Path to the drrty compiler.  Usually "./drrty.native"
# Try "_build/drrty.native" if ocamlbuild was unable to create a symbolic link.
DRRTY="./drrty.native"
#DRRTY="_build/drrty.native"

SignalError() {
    if [ $error -eq 0 ] ; then
	echo "FAILED"
	error=1
    fi
    echo "  $1"
}


Run() {
    echo $* 1>&2
    eval $* || {
	SignalError "$1 failed on $*"
	return 1
    }
}

basename=`echo $1 | sed 's/.*\\///
                             s/.drrt//'`

generatedfiles=""

    generatedfiles="$generatedfiles ${basename}.ll ${basename}.s ${basename}.exe ${basename}.out ${basename}.html" &&
    Run "$DRRTY" "$1" ">" "${basename}.ll" &&
    Run "$LLC" "-relocation-model=pic" "${basename}.ll" ">" "${basename}.s" &&
    Run "$CC" "-o" "${basename}.exe" "${basename}.s" "htmllibrary.o" "listlibrary.o" && 
    Run "./${basename}.exe" > "${basename}.html"